<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.particles &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.particles</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.particles</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot; Module to deal with list of particles.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">List</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">,</span> <span class="n">Dict</span><span class="p">,</span> <span class="n">Optional</span><span class="p">,</span> <span class="n">Union</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_list</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">check_list_in_list</span><span class="p">,</span>
    <span class="n">remove_list_from_list</span><span class="p">,</span>
    <span class="n">_type_to_list</span>
<span class="p">)</span>
<span class="kn">from</span> <span class="nn">lib.handle.handle_dict</span> <span class="kn">import</span> <span class="n">_none_to_dict</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">particles</span>


<div class="viewcode-block" id="daughter_to_mother_particles"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.particles.daughter_to_mother_particles">[docs]</a><span class="k">def</span> <span class="nf">daughter_to_mother_particles</span><span class="p">(</span>
    <span class="n">list_particles</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">int</span><span class="p">],</span>
    <span class="n">dict_daughter_to_mother_particles</span><span class="p">:</span> <span class="nb">dict</span>
        <span class="o">=</span> <span class="n">particles</span><span class="o">.</span><span class="n">dict_daughter_to_mother_particles</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="nb">int</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Remove the daughter particles of a list of particles,</span>
<span class="sd">    in order to only keep the mother particles, if all the daughter particles</span>
<span class="sd">    are in the list of particles.</span>

<span class="sd">    Args:</span>
<span class="sd">        list_particles: list of particles</span>
<span class="sd">        dict_daughter_to_mother_particles: associates a</span>
<span class="sd">            tuple of daughter particle with just the mother particle</span>

<span class="sd">    Returns:</span>
<span class="sd">        list of mother particles</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">for</span> <span class="n">list_daughter_particles</span><span class="p">,</span> <span class="n">mother_particle</span> \
            <span class="ow">in</span> <span class="n">dict_daughter_to_mother_particles</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>

        <span class="k">if</span> <span class="n">check_list_in_list</span><span class="p">(</span><span class="n">list_daughter_particles</span><span class="p">,</span> <span class="n">list_particles</span><span class="p">):</span>
            <span class="n">list_particles</span> <span class="o">=</span> <span class="n">remove_list_from_list</span><span class="p">(</span>
                <span class="n">list_particles</span><span class="p">,</span> <span class="n">list_daughter_particles</span>
            <span class="p">)</span>
            <span class="n">list_particles</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">mother_particle</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">list_particles</span></div>


<div class="viewcode-block" id="get_label_from_list_particles"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.particles.get_label_from_list_particles">[docs]</a><span class="k">def</span> <span class="nf">get_label_from_list_particles</span><span class="p">(</span>
        <span class="n">list_particles</span><span class="p">:</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">],</span>
        <span class="n">dict_particle_labels</span><span class="p">:</span> <span class="n">Dict</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="nb">str</span><span class="p">],</span>
        <span class="n">sep</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Transform a list of particle into a long string indicating all</span>
<span class="sd">    the particles.</span>

<span class="sd">    Args:</span>
<span class="sd">        list_particles: list of particles.</span>
<span class="sd">        dict_particle_labels: associates a particle name with its labels</span>
<span class="sd">        sep: what to put between the label of two particles in the long</span>
<span class="sd">            string that is returned</span>

<span class="sd">    Returns:</span>
<span class="sd">        Long string that contains the list of the labels of the particles</span>
<span class="sd">        in `list_particles`</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">return</span> <span class="n">sep</span><span class="o">.</span><span class="n">join</span><span class="p">([</span>
        <span class="n">dict_particle_labels</span><span class="p">[</span><span class="n">particle</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">particle</span> <span class="ow">in</span> <span class="n">list_particles</span>
    <span class="p">]</span>
    <span class="p">)</span></div>


<div class="viewcode-block" id="get_list_columns"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.particles.get_list_columns">[docs]</a><span class="k">def</span> <span class="nf">get_list_columns</span><span class="p">(</span>
    <span class="n">dict_particle_observables</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span>
        <span class="n">Dict</span><span class="p">[</span><span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">Tuple</span><span class="p">[</span><span class="nb">str</span><span class="p">]],</span> <span class="n">Union</span><span class="p">[</span><span class="nb">str</span><span class="p">,</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]]]]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">)</span> <span class="o">-&gt;</span> <span class="n">List</span><span class="p">[</span><span class="nb">str</span><span class="p">]:</span>
    <span class="sd">&quot;&quot;&quot; Get the list of columns related to particles from list of particles</span>
<span class="sd">    and list of observables</span>

<span class="sd">    Args:</span>
<span class="sd">        dict_particle_observables: associates a particle or a tuple of</span>
<span class="sd">            particles with a list of observables. The key can also</span>
<span class="sd">            be ``&quot;all&quot;`` for all the particles, and ``&quot;long&quot;`` for</span>
<span class="sd">            particles with long tracks (basically the final-state particles)</span>
<span class="sd">        **kwargs: same as `dict_particle_observables` but the</span>
<span class="sd">            keys must be strings.</span>
<span class="sd">    Returns:</span>
<span class="sd">        list of columns, which are the observables of the particles defined </span>
<span class="sd">        by the dictionnary ``dict_particle_observables``</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dict_particle_observables</span> <span class="o">=</span> <span class="n">_none_to_dict</span><span class="p">(</span><span class="n">dict_particle_observables</span><span class="p">)</span>
    <span class="n">dict_particle_observables</span> <span class="o">=</span> <span class="p">{</span>
        <span class="o">**</span><span class="n">dict_particle_observables</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">}</span>
    <span class="n">list_particle_columns</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">list_particles</span><span class="p">,</span> <span class="n">list_observables</span> <span class="ow">in</span> <span class="n">dict_particle_observables</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
        <span class="k">if</span> <span class="n">list_particles</span> <span class="o">==</span> <span class="s2">&quot;all&quot;</span><span class="p">:</span>
            <span class="n">list_particles</span> <span class="o">=</span> <span class="n">particles</span><span class="o">.</span><span class="n">list_all_particles</span>
        <span class="k">elif</span> <span class="n">list_particles</span> <span class="o">==</span> <span class="s2">&quot;long&quot;</span><span class="p">:</span>
            <span class="n">list_particles</span> <span class="o">=</span> <span class="n">particles</span><span class="o">.</span><span class="n">list_long_track_particles</span>
        <span class="k">elif</span> <span class="n">list_particles</span> <span class="o">==</span> <span class="s2">&quot;daughter&quot;</span><span class="p">:</span>
            <span class="n">list_particles</span> <span class="o">=</span> <span class="n">particles</span><span class="o">.</span><span class="n">list_daughter_particles</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">list_particles</span> <span class="o">=</span> <span class="n">_type_to_list</span><span class="p">(</span><span class="n">list_particles</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span>
        <span class="n">list_observables</span> <span class="o">=</span> <span class="n">_type_to_list</span><span class="p">(</span><span class="n">list_observables</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span>

        <span class="n">list_particle_columns</span> <span class="o">+=</span> <span class="p">[</span>
            <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{particles.dict_particle_aliases[particle]}</span><span class="s2">_</span><span class="si">{observable}</span><span class="s2">&quot;</span>
            <span class="k">for</span> <span class="n">particle</span> <span class="ow">in</span> <span class="n">list_particles</span>
            <span class="k">for</span> <span class="n">observable</span> <span class="ow">in</span> <span class="n">list_observables</span>
        <span class="p">]</span>

    <span class="k">return</span> <span class="n">list_particle_columns</span></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>